from math import ceil, floor, sqrt, pow


def sqrt_left(a, base):
    l = 0
    r = a
    while r - l > 0.001:
        cur = (l + r) / 2
        if cur**base > a:
            r = cur
        else:
            l = cur
    return l


a = int(input())
b = int(input())
k = int(input())

if b == 10**18 and k == 0:
    print(1000)
    exit(0)
else:
    min_l = ceil(pow(a, 1/3))
ans = 0

i = min_l
while i ** 3 <= b:
    maxX = floor(sqrt(min(i ** 3 + k, b)))
    minX = ceil(sqrt(max(i ** 3 - k, a)))
    ans += maxX - minX + 1
    i += 1
print(ans)
