import java.util.Scanner;

public class B {

	public static long maxX(int y, long a, long b, long k) {
		long left = (long) (Math.ceil(Math.sqrt(a)) - 1);
		long right = (long) (Math.ceil(Math.sqrt(b)) + 1);

		while (right - left > 1) {
			long cur = (left + right) / 2;
			if (cur * cur - y * y * y > k) {
				right = cur;
			} else {
				left = cur;
			}
		}
		return left;
	}

	public static long minX(int y, long a, long b, long k) {
		long left = (long) (Math.ceil(Math.sqrt(a)) - 1);
		long right = (long) (Math.ceil(Math.sqrt(b)) + 1);

		while (right - left > 1) {
			long cur = (left + right) / 2;
			if (y * y * y - cur * cur > k) {
				left = cur;
			} else {
				right = cur;
			}
		}
		return right;
	}

	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);

		long a = sc.nextLong();
		long b = sc.nextLong();
		long k = sc.nextLong();

		int min = (int) (Math.ceil(Math.pow(a, 1 / 3.0)));
		int max = (int) (Math.floor(Math.pow(b, 1 / 3.0)));
		long ans = 0;
		for (int i = min; i <= max; i++) {
			ans += (maxX(i, a, b, k) - minX(i, a, b, k) + 1);
		}
		System.out.println(ans);
	}

}
