import java.util.Scanner;

public class B {

	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);

		long a = sc.nextLong();
		long b = sc.nextLong();
		long k = sc.nextLong();

		long min = (long) Math.ceil(sqrt(a, 3));
		long ans = 0;

		for (long i = min; i * i * i <= b; i++) {
			double maxX = Math.floor(sqrt_right(Math.min(i * i * i + k, b), 2));
			double minX = Math.ceil(sqrt(Math.max(a, i * i * i - k), 2));
			ans += maxX - minX + 1;
		}
		System.out.println(ans);

	}

	private static double sqrt(long a, long base) {
		double left = 0;
		double right = a + 1;
		while (right - left > 0.00001) {
			double cur = (right + left) / 2;
			if (Math.pow(cur, base) > a) {
				right = cur;
			} else {
				left = cur;
			}
		}
		return left;
	}
	
	private static double sqrt_right(long a, long base) {
		double left = 0;
		double right = a + 1;
		while (right - left > 0.00001) {
			double cur = (right + left) / 2;
			if (Math.pow(cur, base) > a) {
				right = cur;
			} else {
				left = cur;
			}
		}
		return right;
	}
	

}
