
import java.io.*;
import java.util.*;

public class Solve {
	public void solve() throws IOException {
		int n = nextInt();
		int m = nextInt();
		ArrayList<LinkedList<Integer>> list = new ArrayList<>();
		for (int i = 0; i < n; i++) {
			list.add(new LinkedList<>());
		}
		for (int i = 1; i < n; i++) {
			int a = nextInt();
			list.get(a - 1).add(i);
			list.get(i).add(a - 1);
		}

		int[] heights = new int[n];

		LinkedList<Integer> pq = new LinkedList<>();

		pq.add(0);
		boolean[] isUsed = new boolean[n];
		int max1 = 0;
		heights[0] = 1;
		while (!pq.isEmpty()) {
			int vertex = pq.poll();
			isUsed[vertex] = true;
			for (int i = 0; i < list.get(vertex).size(); i++) {
				if (!isUsed[list.get(vertex).get(i)]) {
					pq.add(list.get(vertex).get(i));
					heights[list.get(vertex).get(i)] = heights[vertex] + 1;
					if (heights[list.get(vertex).get(i)] > heights[max1]) {
						max1 = list.get(vertex).get(i);
					}
				}
			}

		}
		isUsed = new boolean[n];
		int[] heights2 = new int[n];
		pq.add(max1);
		heights2[max1] = 1;
		int max2 = max1;
		while (!pq.isEmpty()) {
			int vertex = pq.poll();
			isUsed[vertex] = true;
			for (int i = 0; i < list.get(vertex).size(); i++) {
				if (!isUsed[list.get(vertex).get(i)]) {
					pq.add(list.get(vertex).get(i));
					heights2[list.get(vertex).get(i)] = heights2[vertex] + 1;
					if (heights2[list.get(vertex).get(i)] > heights2[max2]
							&& list.get(list.get(vertex).get(i)).size() == 1) {
						max2 = list.get(vertex).get(i);
					}
				}
			}
		}
		System.out.println(heights2[max2] + heights[max1] * 2 * (m - 1));

	}

	public void run() {
		try {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new Solve().run();
	}

}
